#include <stdio.h>
#include <stdlib.h>

int ** main_table ;
int * tree_a;
int * tree_b;
int vertices;

void set(int * arr, int vertex, int depth){
	int i;
	arr[vertex]++;
	if(depth>0){
		for(i=0; i<3; i++){
			if(arr[main_table[i][vertex]]==0){
				set(arr,main_table[i][vertex],depth-1);
			}
		}
	}			
}

int vertex_disjoint(int fulltree_a, int fulltree_b, int depth_a, int depth_b){
	
	int i;
	tree_a=(int*)malloc(vertices*sizeof(int));
	tree_b=(int*)malloc(vertices*sizeof(int));
	
	for(i=0; i<vertices; i++){
		tree_a[i]=0;
		tree_b[i]=0;
	}
	
	set(tree_a, fulltree_a, depth_a);
	set(tree_b, fulltree_b, depth_b);
	
	i=0;
	while(i<vertices && !(tree_a[i] && tree_b[i])){
		i++;
	}	
	free(tree_a);
	free(tree_b);
	
	if(i==vertices)
		return 1;	
	else
		return 0;	
}	
