#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int ** main_table;
int * flow_table[3];
int vertices;
FILE * input;

void print_main_table(){
	int i,j;
	for(i=0; i<vertices; i++){
  	 printf("\n%d: ",i);
     for(j=0;j<3; j++){  	
       printf("%d ", main_table[j][i]);
  	 }
   }
     printf("\n");
}

void main_table_free(){
  int i;
  for(i=0; i<3; i++){
  	free(main_table[i]);   	
  }
  free(main_table);	
}

int read(int type){
   int i,j,v; 
   char s[100];
   main_table=(int **)malloc(3*sizeof(int*));
   for(i=0; i<3; i++){
   	 main_table[i]=(int *)malloc(vertices*sizeof(int));
   }  
   fscanf(input,"%s",s);     
  switch(type){
  	case 1:  		
		for(i=0; i<3; i++){
  	  		for(j=0;j<vertices; j++){    	  		  	
  	    		fscanf(input,"%d",&v);  
  				if(feof(input)){
  				 	main_table_free();
   	 				return 0;
   				}    		
  	    		main_table[i][j]=v;
  	  		}
   	  	}
   	  	break;
   	case 2:
   		for(j=0;j<vertices; j++){  
   			for(i=0; i<3; i++){  	  		  	  		  	
  	    		fscanf(input,"%d",&v);  
  	    		if(feof(input)){
  		     	  main_table_free();
   	 			  return 0;
   				}    		  	    
  	    		main_table[i][j]=v;
   			}
   	  	}	
   	    break;
  	
  	case 3:
		for(i=0; i<3; i++){
  	  		for(j=0;j<vertices; j++){    	  		  	
  	    		fscanf(input,"%d",&v);  
  				if(feof(input)){
  				 	main_table_free();
   	 				return 0;
   				}    		
  	    		main_table[i][j]=v-1;
  	  		}
   	  	}
   	  	break;
   	case 4:
   		for(j=0;j<vertices; j++){  
   			for(i=0; i<3; i++){  	  		  	  		  	
  	    		fscanf(input,"%d",&v);  
  	    		if(feof(input)){
  		     	  main_table_free();
   	 			  return 0;
   				}    		  	    
  	    		main_table[i][j]=v-1;  	    		
   			}
   	  	}	
   	    break;
  	}
  
  return 1; 
}
