#include <stdio.h>
#include <stdlib.h>

int ** main_table;
typedef struct front_item{
	int vertex;
	struct front_item * next;
	int distance;
} FRONT_ITEM;


int front_empty(FRONT_ITEM * begin){
	return (begin==NULL);
}
void front_print(FRONT_ITEM * begin, char * text){
	printf("%s: ", text);
	if (front_empty(begin)){
		printf("\nfront is empty");
	}
	else{
		while (begin != NULL){
			printf("%d ", begin->vertex);
		
			begin=begin->next;	
		}
	}
	printf("\n");
}

FRONT_ITEM * front_add(FRONT_ITEM ** begin, FRONT_ITEM * end, int vertex, int distance){
	if(end==NULL){
		end=(FRONT_ITEM * )malloc(sizeof(FRONT_ITEM));
		end->next=NULL;
		end->vertex=vertex;
		end->distance=distance;
		*begin = end;
		return end;
	}
	else{
		end->next=(FRONT_ITEM * )malloc(sizeof(FRONT_ITEM));
		end->next->next=NULL;
		end->next->vertex=vertex;
		end->next->distance=distance;
		return end->next;
	}
	
}
FRONT_ITEM * front_remove(FRONT_ITEM ** begin, FRONT_ITEM ** end){
	if(*begin==NULL){
		return NULL;
	}
	else{
			FRONT_ITEM * del = *begin;
			if(*begin == *end){		  	
		  	   *end=NULL;	
			}
			*begin=(*begin)->next;
		  	return del;
	}
}
FRONT_ITEM * front_delete(FRONT_ITEM * begin){
	FRONT_ITEM * pom;
	while(begin!=NULL){
		pom=begin;
		begin=begin->next;
		free(pom);
	}
	return begin;
}
int front_contains(FRONT_ITEM * begin, int vertex){
	while (begin!=NULL && begin->vertex != vertex){
		
		begin=begin->next;
	}
	
	if (begin==NULL) return 0; 
	else return 1;
}
